//+------------------------------------------------------------------+
//|                                                 sFractals v1.mq4 |
//|                      Copyright  2010, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"


#define EAName "sFractals v1"

#include <stdlib.mqh>


extern string S1="---------------- Indicator Settings";

extern double MovingPeriod= 10;
extern double MovingShift= 0;
extern double MovingMode= 2;
extern double MovingPrice= 0;



extern string S2="---------------- Money Management";

extern double Lots= 0.10;     //|-----------------------lots size
extern double MinLots= 0.10;  //|-------------------minlots
extern double MaxLots= 0.10;  //|--------------------maxlots
extern int    StopLoss= 0;    //|------------------------stop loss
extern int    TakeProfit= 0;  //|----------------------take profit
extern int    MaxOrders= 40;  //|---------------------maximum orders allowed
extern int    Slippage= 3;    //|------------------------slippage
extern int    Magic= 2010;    //|------------------------magic number


extern string S3="---------------- Time Filter";

extern bool TradeOnSunday= true;                //|---------------time filter on sunday
extern bool MondayToThursdayTimeFilter= false;  //|-time filter the week
extern int  MondayToThursdayStartHour= 0;       //|-------start hour time filter the week
extern int  MondayToThursdayEndHour= 24;        //|--------end hour time filter the week
extern bool FridayTimeFilter= false;            //|-----------time filter on friday
extern int  FridayStartHour= 0;                 //|-----------------start hour time filter on friday
extern int  FridayEndHour= 21;                  //|------------------end hour time filter on friday


extern string S4="---------------- Orders Management";

extern bool    StopManageAcc= false;    //| Stop of Manage Account switch(Close All Trades)
extern int     MagicClose= 0;           //| Magic Number ( 0 - for All positions)
extern bool    UsePips= true;    
extern double  ProfitTarget= 100;       //| Profit target in pips or USD       	
extern double  MaxLoss= 100;            //| Maximum total loss in pips or USD
extern bool    ReverseSystem= false;    //|--------------Buy instead of sell, sell instead of buy     



datetime PreviousBarTime1;
datetime PreviousBarTime2;

int digits;
double point;

bool TradeAsLongAs=false;

int totalPips=0;
double  totalProfits=0;
bool CloseSignal=false;




//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//---- 
   //CloseSignal=false;
//----
   return(0);
  }

// -------- Scan Open Trades
int ScanOpenTrades()
{   
   int total = OrdersTotal();
   int numords = 0;
    
   for(int cnt=0; cnt<=total-1; cnt++) 
   {        
   OrderSelect(cnt, SELECT_BY_POS);            
      if(OrderType()<=OP_SELL)
      {
      if(MagicClose > 0) if(OrderMagicNumber() == Magic) numords++;
      if(MagicClose == 0) numords++;
      }
   }   
   return(numords);
}

//---------- Closing of Open Orders      
void OpenOrdClose()
{
    int total=OrdersTotal();
    for (int cnt=0;cnt<total;cnt++)
    { 
    OrderSelect(cnt, SELECT_BY_POS);   
    int mode=OrderType();
    bool res = false; 
    bool condition = false;
    if ( MagicClose>0 && OrderMagicNumber()==Magic ) condition = true;
    else if ( MagicClose==0 ) condition = true;
      if (condition && ( mode==OP_BUY || mode==OP_SELL ))
      { 
//----------- BUY Orders         
         if(mode==OP_BUY)
         {  
         res = OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_BID),3,Yellow);
               
            if( !res )
            {
            Print(" BUY: OrderClose failed with error #",GetLastError());
            Print(" Ticket=",OrderTicket());
            Sleep(3000);
            }
         break;
         }
         else     

//---------- SELL Orders          
         if( mode == OP_SELL)
         {
         res = OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_ASK),3,White);
                 
            if( !res )
            {
            Print(" SELL: OrderClose failed with error #",GetLastError());
            Print(" Ticket=",OrderTicket());
            Sleep(3000);
            }
         break;    
         }  
      }                  
   }
}

void TotalProfit()
{
   int total=OrdersTotal();
   totalPips = 0;
   totalProfits = 0;
   for (int cnt=0;cnt<total;cnt++)
   { 
   OrderSelect(cnt, SELECT_BY_POS);   
   int mode=OrderType();
   bool condition = false;
   if ( MagicClose>0 && OrderMagicNumber()==Magic ) condition = true;
   else if ( MagicClose==0 ) condition = true;   
      if (condition)
      {      
         switch (mode)
         {
         case OP_BUY:
            totalPips += MathRound((MarketInfo(OrderSymbol(),MODE_BID)-OrderOpenPrice())/MarketInfo(OrderSymbol(),MODE_POINT));
            //totalPips += MathRound((Bid-OrderOpenPrice())/Point);
            totalProfits += OrderProfit();
            break;
            
         case OP_SELL:
            totalPips += MathRound((OrderOpenPrice()-MarketInfo(OrderSymbol(),MODE_ASK))/MarketInfo(OrderSymbol(),MODE_POINT));
            //totalPips += MathRound((OrderOpenPrice()-Ask)/Point);
            totalProfits += OrderProfit();
            break;
         }
      }            
	}
}

void ChartComment()
{
   string sComment   = "";
   string sp         = "----------------------------------------\n";
   string NL         = "\n";

   sComment = sp;
   sComment = sComment + "Open Positions=" + ScanOpenTrades() + NL;
   sComment = sComment + "Current Profit(pips)= " + totalPips + NL;
   sComment = sComment + "Current Profit(USD) = " + DoubleToStr(totalProfits,2) + NL; 
   sComment = sComment + sp;
  
   Comment(sComment);
}	  


 
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+

int deinit()
{
  return(0);
}



//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+

int start()

{

if(ScanOpenTrades()==0) CloseSignal=false;
   
   TotalProfit();
   ChartComment();
    
   if (!StopManageAcc)
   {
      if(ScanOpenTrades() > 0 && !CloseSignal && (ProfitTarget>0 || MaxLoss>0))
      {
         if(UsePips)
         {
         if(ProfitTarget > 0 && totalPips>=ProfitTarget) CloseSignal=true;    
         if(MaxLoss > 0 && totalPips <= -MaxLoss) CloseSignal=true; 
         //Print("pips: totalPips =",totalPips," signal=",CloseSignal); 
         }
         else
         {
         if(ProfitTarget > 0 && totalProfits>=ProfitTarget) CloseSignal=true;
         if(MaxLoss > 0 && totalProfits <= -MaxLoss) CloseSignal=true;
         //Print("usd: tatalprofit=",totalProfits," signal=",CloseSignal);
         }        
      }   
   }
   else 
   { if (ScanOpenTrades() > 0) CloseSignal=true;}    
   
   //Print("Signal=",CloseSignal);
   if( CloseSignal ) OpenOrdClose();
          
    return(0);
  }
  
 }


//|---------signal conditions

   int limit=1;
   for(int i=1;i<=limit;i++)
   {
   

//|---------main signal

      
      double s_0 = iCustom(NULL, 0, "sFractals",0,2);
      double s_1 = iCustom(NULL, 0, "sFractals",1,2);

      
      double ma1=iMA(NULL,0,MovingPeriod,MovingShift,MovingMode ,MovingPrice ,0);
      
      bool BUY=false;
      bool SELL=false;

      if(
      s_1 > 0 &&  ((Open[0]<ma1 && Close[0]>ma1)||(Open[0]>ma1 && Close[0]>ma1))
      )BUY=true;
      
      if(
      s_0 > 0 &&  ((Open[0]>ma1 && Close[0]<ma1)||(Open[0]<ma1 && Close[0]<ma1))
      )SELL=true;
      
      if ((BUY == false && SELL == false)&& (Open[1]>Close[1]))SELL = true;
      if ((BUY == false && SELL == false)&& (Open[1]<Close[1]))BUY = true;
      
      bool SignalBUY=false;
      bool SignalSELL=false;
      
      if(BUY/*&&MABUY*/)if(ReverseSystem)SignalSELL=true;else SignalBUY=true;
      if(SELL/*&&MASELL*/)if(ReverseSystem)SignalBUY=true;else SignalSELL=true;
      
   }


//|---------time filter

   if((TradeOnSunday==false&&DayOfWeek()==0)||(MondayToThursdayTimeFilter&&DayOfWeek()>=1&&DayOfWeek()<=4&&!(Hour()>=MondayToThursdayStartHour&&Hour()<MondayToThursdayEndHour))||(FridayTimeFilter&&DayOfWeek()==5&&!(Hour()>=FridayStartHour&&Hour()<FridayEndHour)))
   {
      return(0);
   }
   
//|---------open orders

   double SL,TP,ILots;
   int Ticket,Expire=0;
   

   if((CountOrders(OP_BUY,Magic)+CountOrders(OP_SELL,Magic))<MaxOrders)
   {  
      if((SignalBUY&&((TradeAsLongAs==false && NewBarBuy())||(TradeAsLongAs))))
      {
         
         if(ILots<MinLots)ILots=MinLots;if(ILots>MaxLots)ILots=MaxLots;
         
         Ticket=OrderSend(Symbol(),OP_BUY,ILots,Ask,Slippage,SL,TP,EAName,Magic,0,Blue);
         
         
      }
      if((SignalSELL&&((TradeAsLongAs==false && NewBarSell())||(TradeAsLongAs))))
      {
         
         if(ILots<MinLots)ILots=MinLots;if(ILots>MaxLots)ILots=MaxLots;
         
         Ticket=OrderSend(Symbol(),OP_SELL,ILots,Bid,Slippage,SL,TP,EAName,Magic,0,Red);
         
         
      }
   }

//|---------not enough money warning

   int err=0;
   if(Ticket<0)
   {
      if(GetLastError()==134)
      {
         err=1;
         Print("Not enough money!");
      }
      return (-1);
   }
   return(0); 
}



//|---------count orders

int CountOrders(int Type,int Magic)
{
   int _CountOrd;
   _CountOrd=0;
   for(int i=0;i<OrdersTotal();i++)
   {
      OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      if(OrderSymbol()==Symbol())
      {
         if((OrderType()==Type&&(OrderMagicNumber()==Magic)||Magic==0))_CountOrd++;
      }
   }
   return(_CountOrd);
}


//|---------allow one action per bar

bool NewBarBuy()
{
   
   if(PreviousBarTime1<Time[0])
   {
      PreviousBarTime1=Time[0];
      return(true);
   }
   return(false);
}

bool NewBarSell()
{
   
   if(PreviousBarTime2<Time[0])
   {
      PreviousBarTime2=Time[0];
      return(true);
   }
   return(false);
}







